// Copyright (c) 2016, 2018, 2025, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Data Science API
//
// Use the Data Science API to organize your data science work, access data and computing resources, and build, train, deploy and manage models and model deployments. For more information, see Data Science (https://docs.oracle.com/iaas/data-science/using/data-science.htm).
//

package datascience

import (
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// ConfigurationProperty Property that is used for provisioning of the given MlApplicationInstance. It is validated against configurationSchema defined in referenced MlApplicationImplementation. The value is mandatory with exception for ConfigurationProperty of SECRET type where read operation does not return value field as it contains plain text secret and update operation does not have to contain value field when the secret value should not be updated.
type ConfigurationProperty struct {

	// Key of configuration property
	Key *string `mandatory:"true" json:"key"`

	// Value of configuration property
	Value *string `mandatory:"false" json:"value"`
}

func (m ConfigurationProperty) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m ConfigurationProperty) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}
